Index: src/Actions/ParserAction/SetParserParametersAction.cpp
===================================================================
--- src/Actions/ParserAction/SetParserParametersAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/ParserAction/SetParserParametersAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -27,4 +27,5 @@
 #include "Actions/ValueStorage.hpp"
 
+#include <algorithm>
 #include <iostream>
 #include <string>
@@ -40,5 +41,5 @@
 Action::state_ptr ParserSetParserParametersAction::performCall() {
   // get parser
-  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(params.parsername);
+  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(params.parsername.get());
   FormatParser_Parameters *parameters = FormatParserStorage::getInstance().get(type).parameters;
   ASSERT(parameters != NULL,
@@ -50,5 +51,7 @@
 
   // obtain information
-  std::stringstream newparamstream(params.newparams);
+  std::stringstream newparamstream;
+  const std::vector< std::string > keyvalues = params.newparams.get();
+  std::for_each(keyvalues.begin(), keyvalues.end(), newparamstream << boost::lambda::_1 << ";");
   newparamstream >> *parameters;
 
@@ -59,5 +62,5 @@
   ParserSetParserParametersState *state = assert_cast<ParserSetParserParametersState*>(_state.get());
 
-  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(state->params.parsername);
+  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(state->params.parsername.get());
   FormatParser_Parameters *parser = FormatParserStorage::getInstance().get(type).parameters;
   std::stringstream oldparamstream(state->oldparams);
@@ -70,7 +73,9 @@
   ParserSetParserParametersState *state = assert_cast<ParserSetParserParametersState*>(_state.get());
 
-  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(state->params.parsername);
+  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(state->params.parsername.get());
   FormatParser_Parameters *parser = FormatParserStorage::getInstance().get(type).parameters;
-  std::stringstream newparamstream(state->params.newparams);
+  std::stringstream newparamstream;
+  const std::vector< std::string > keyvalues = state->params.newparams.get();
+  std::for_each(keyvalues.begin(), keyvalues.end(), newparamstream << boost::lambda::_1 << ";");
   newparamstream >> *parser;
 
Index: src/Actions/ParserAction/SetParserParametersAction.def
===================================================================
--- src/Actions/ParserAction/SetParserParametersAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/ParserAction/SetParserParametersAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,14 +7,22 @@
 
 // all includes and forward declarations necessary for non-integral types below
+#include <vector>
+#include <string>
 
+#include "Parameters/Validators/STLVectorValidator.hpp"
+#include "Parameters/Validators/Specific/KeyValueValidator.hpp"
+#include "Parameters/Validators/Specific/ParserTypeValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (std::string)(std::string)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::string)(std::vector<std::string>)
 #define paramtokens ("set-parser-parameters")("parser-parameters")
 #define paramdescriptions ("name of the parser to change")("parameter (key = value;)")
-#define paramdefaults (NODEFAULT)(NODEFAULT)
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)
 #define paramreferences (parsername)(newparams)
+#define paramvalids \
+(ParserTypeValidator())\
+(STLVectorValidator< std::vector<std::string> >(1, 99, KeyValueValidator()))
 
 #define statetypes (std::string)
Index: src/Actions/ParserAction/SetTremoloAtomdataAction.cpp
===================================================================
--- src/Actions/ParserAction/SetTremoloAtomdataAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/ParserAction/SetTremoloAtomdataAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -41,31 +41,45 @@
   FormatParser<tremolo> &parser = FormatParserStorage::getInstance().getParser<tremolo>();
 
-  LOG(1, "Setting Tremolo's ATOMDATA to: '" << params.atomdata_string << "'");
+  LOG(1, "Setting Tremolo's ATOMDATA to: '" << params.atomdata_string.get() << "'");
 
-  parser.setAtomData(params.atomdata_string);
+  const std::string old_atomdata = parser.getAtomData();
 
-  return Action::success;
+  if (params.atomdata_reset.get())
+    parser.resetAtomData(params.atomdata_string.get());
+  else
+    parser.setAtomData(params.atomdata_string.get());
+
+  return Action::state_ptr(new ParserSetTremoloAtomdataState(old_atomdata, params));
 }
 
 Action::state_ptr ParserSetTremoloAtomdataAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  ParserSetTremoloAtomdataState *state = assert_cast<ParserSetTremoloAtomdataState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  FormatParser<tremolo> &parser = FormatParserStorage::getInstance().getParser<tremolo>();
+  LOG(1, "INFO: Reverting to 'ATOMDATA " << state->old_atomdata << "'.");
+  parser.resetAtomData(state->old_atomdata);
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr ParserSetTremoloAtomdataAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  ParserSetTremoloAtomdataState *state = assert_cast<ParserSetTremoloAtomdataState*>(_state.get());
+
+  FormatParser<tremolo> &parser = FormatParserStorage::getInstance().getParser<tremolo>();
+
+  if (state->params.atomdata_reset.get())
+    parser.resetAtomData(state->params.atomdata_string.get());
+  else
+    parser.setAtomData(state->params.atomdata_string.get());
+
+  return Action::state_ptr(_state);
 }
 
 bool ParserSetTremoloAtomdataAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool ParserSetTremoloAtomdataAction::shouldUndo() {
-  return false;
+  return true;
 }
 /** =========== end of function ====================== */
Index: src/Actions/ParserAction/SetTremoloAtomdataAction.def
===================================================================
--- src/Actions/ParserAction/SetTremoloAtomdataAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/ParserAction/SetTremoloAtomdataAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,15 +9,21 @@
 #include <boost/filesystem.hpp>
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Specific/AtomDataValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (std::string)
-#define paramtokens ("set-tremolo-atomdata")
-#define paramdescriptions ("properties to set, space-separated")
-#undef paramdefaults
-#define paramreferences (atomdata_string)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::string)(bool)
+#define paramtokens ("set-tremolo-atomdata")("reset")
+#define paramdescriptions ("properties to set, space-separated")("whether to append (false) or overwrite (true) with given atomdata")
+#define paramdefaults (NOPARAM_DEFAULT)(PARAM_DEFAULT(true))
+#define paramreferences (atomdata_string)(atomdata_reset)
+#define paramvalids \
+(AtomDataValidator()) \
+(DummyValidator<bool>())
 
-#undef statetypes
-#undef statereferences
+#define statetypes (std::string)
+#define statereferences (old_atomdata)
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
Index: src/Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.cpp
===================================================================
--- src/Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -47,5 +47,5 @@
 
   // set the new default
-  RandomNumberDistributionFactory::getInstance().setCurrentType(params.distribution_type);
+  RandomNumberDistributionFactory::getInstance().setCurrentType(params.distribution_type.get());
   LOG(0, "STATUS: Distribution of random number generator is now: "
       << RandomNumberDistributionFactory::getInstance().getCurrentTypeName());
@@ -55,10 +55,13 @@
       RandomNumberDistributionFactory::getInstance().getPrototype().getParameterSet();
   // set each parameter (that is not -1);
-  if (!params.parameters.isDefault()) {
+  {
+    std::stringstream input(params.parameters.get());
     RandomNumberDistribution_Parameters *currentparameters =
         RandomNumberDistributionFactory::getInstance().getPrototype().getParameterSet();
-    currentparameters->update(params.parameters);
-    LOG(1, "INFO: Changing prototype's parameters to " << params.parameters << ".");
-    RandomNumberDistributionFactory::getInstance().manipulatePrototype(*currentparameters);
+    input >> *currentparameters;  // add new values on top
+    if (!currentparameters->isDefault()) {
+      LOG(1, "Changing prototype's parameters.");
+      RandomNumberDistributionFactory::getInstance().manipulatePrototype(*currentparameters);
+    }
     delete currentparameters;
   }
@@ -71,6 +74,8 @@
   }
 
+  std::stringstream output;
+  output << *oldparameters;
   CommandSetRandomNumbersDistributionState *newstate =
-      new CommandSetRandomNumbersDistributionState(oldtype,*oldparameters,params);
+      new CommandSetRandomNumbersDistributionState(oldtype,output.str(),params);
   delete oldparameters;
   return Action::state_ptr(newstate);
@@ -94,7 +99,14 @@
 
   // set each parameter back (that is not -1);
-  if (!state->old_parameters.isDefault()) {
-    LOG(1, "INFO: Changing back prototype's parameters to " << state->old_parameters << ".");
-    RandomNumberDistributionFactory::getInstance().manipulatePrototype(state->old_parameters);
+  {
+    std::stringstream input(state->old_parameters);
+    RandomNumberDistribution_Parameters *currentparameters =
+        RandomNumberDistributionFactory::getInstance().getPrototype().getParameterSet();
+    input >> *currentparameters;
+    if (!currentparameters->isDefault()) {
+      LOG(1, "Changing prototype's parameters.");
+      RandomNumberDistributionFactory::getInstance().manipulatePrototype(*currentparameters);
+    }
+    delete currentparameters;
   }
 
@@ -106,6 +118,8 @@
   }
 
+  std::stringstream output;
+  output << *newparameters;
   CommandSetRandomNumbersDistributionState *newstate =
-      new CommandSetRandomNumbersDistributionState(newtype,*newparameters,params);
+      new CommandSetRandomNumbersDistributionState(newtype,output.str(),params);
   delete newparameters;
   return Action::state_ptr(newstate);
Index: src/Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.def
===================================================================
--- src/Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,16 +7,22 @@
 
 // all includes and forward declarations necessary for non-integral types below
-#include "RandomNumbers/RandomNumberDistribution_Parameters.hpp"
+#include <string>
+
+#include "Parameters/Validators/Specific/RandomNumberValidators.hpp"
+#include "Parameters/Validators/Specific/KeyValueValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (std::string)(class RandomNumberDistribution_Parameters)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::string)(std::string)
 #define paramtokens ("set-random-number-distribution")("random-number-distribution-parameters")
 #define paramdescriptions ("name of the distribution from boost::random")("parameter set for requested distribution")
-#define paramdefaults (NODEFAULT)("p=-1")
+#define paramdefaults (NOPARAM_DEFAULT)(PARAM_DEFAULT(std::string("p=-1")))
 #define paramreferences (distribution_type)(parameters)
+#define paramvalids \
+(RandomNumberDistributionNameValidator()) \
+(KeyValueValidator())
 
-#define statetypes (std::string)(RandomNumberDistribution_Parameters)
+#define statetypes (std::string)(std::string)
 #define statereferences (old_distribution_type)(old_parameters)
 
Index: src/Actions/RandomNumbersAction/SetRandomNumbersEngineAction.cpp
===================================================================
--- src/Actions/RandomNumbersAction/SetRandomNumbersEngineAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/RandomNumbersAction/SetRandomNumbersEngineAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -47,5 +47,5 @@
 
   // set the new default
-  RandomNumberEngineFactory::getInstance().setCurrentType(params.engine_type);
+  RandomNumberEngineFactory::getInstance().setCurrentType(params.engine_type.get());
   LOG(0, "STATUS: Engine of random number generator is now: "
       << RandomNumberEngineFactory::getInstance().getCurrentTypeName());
@@ -56,5 +56,5 @@
   // set each parameter (that is not -1);
   {
-    std::stringstream input(params.parameters);
+    std::stringstream input(params.parameters.get());
     RandomNumberEngine_Parameters *currentparameters =
         RandomNumberEngineFactory::getInstance().getPrototype().getParameterSet();
Index: src/Actions/RandomNumbersAction/SetRandomNumbersEngineAction.def
===================================================================
--- src/Actions/RandomNumbersAction/SetRandomNumbersEngineAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/RandomNumbersAction/SetRandomNumbersEngineAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,12 +8,18 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/Specific/RandomNumberValidators.hpp"
+#include "Parameters/Validators/Specific/KeyValueValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)(std::string)
 #define paramtokens ("set-random-number-engine")("random-number-engine-parameters")
 #define paramdescriptions ("name of the pseudo-random engine from boost::random")("seed of the pseudo-random number sequence")
-#define paramdefaults (NODEFAULT)("seed=-1")
+#define paramdefaults (NOPARAM_DEFAULT)(PARAM_DEFAULT(std::string("seed=-1")))
 #define paramreferences (engine_type)(parameters)
+#define paramvalids \
+(RandomNumberEngineNameValidator()) \
+(KeyValueValidator())
 
 #define statetypes (std::string)(std::string)
Index: src/Actions/RedoAction.def
===================================================================
--- src/Actions/RedoAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/RedoAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
Index: src/Actions/SelectionAction/Atoms/AllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AllAtomsAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<atom*>)
Index: src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -47,8 +47,8 @@
   RealSpaceMatrix RotationMatrix;
 
-  RotationMatrix.setRotation(params.Xangle, params.Yangle, params.Zangle);
+  RotationMatrix.setRotation(params.Xangle.get(), params.Yangle.get(), params.Zangle.get());
 
-  LOG(1, "Selecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << params.position << " and extension of " << params.extension << ".");
-  Shape s = translate(transform(stretch(Cuboid(),params.extension),RotationMatrix),params.position);
+  LOG(1, "Selecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << params.position.get() << " and extension of " << params.extension.get() << ".");
+  Shape s = translate(transform(stretch(Cuboid(),params.extension.get()),RotationMatrix),params.position.get());
   std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection() && AtomsByShape(s));
   World::getInstance().selectAllAtoms(AtomsByShape(s));
Index: src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -11,12 +11,22 @@
 class atom;
 
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+#include "Parameters/Validators/Specific/RotationAngleValidator.hpp"
+#include "Parameters/Validators/Specific/VectorPositiveComponentsValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (Vector)(Vector)(double)(double)(double)
 #define paramtokens ("select-atoms-inside-cuboid")("position")("angle-x")("angle-y")("angle-z")
 #define paramdescriptions ("dimensions of cuboid")("position in R^3 space")("angle of a rotation around x axis")("angle of a rotation around y axis")("angle of a rotation around z axis")
-#define paramdefaults (NODEFAULT)(NODEFAULT)("0.")("0.")("0.")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))
 #define paramreferences (extension)(position)(Xangle)(Yangle)(Zangle)
+#define paramvalids \
+(VectorPositiveComponentsValidator()) \
+(BoxVectorValidator()) \
+(RotationAngleValidator()) \
+(RotationAngleValidator()) \
+(RotationAngleValidator())
 
 #define statetypes (std::vector<atom*>)(Shape)
Index: src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -44,6 +44,6 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionAllAtomsInsideSphereAction::performCall() {
-  LOG(1, "Selecting all atoms inside a sphere at " << params.position << " with radius " << params.radius << ".");
-  Shape s = translate(resize(Sphere(),params.radius),params.position);
+  LOG(1, "Selecting all atoms inside a sphere at " << params.position.get() << " with radius " << params.radius.get() << ".");
+  Shape s = translate(resize(Sphere(),params.radius.get()),params.position.get());
   std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection() && AtomsByShape(s));
   World::getInstance().selectAllAtoms(AtomsByShape(s));
Index: src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,7 +10,10 @@
 class Shape;
 
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (double)(Vector)
 #define paramtokens ("select-atoms-inside-sphere")("position")
@@ -18,4 +21,7 @@
 #undef paramdefaults
 #define paramreferences (radius)(position)
+#define paramvalids \
+(BoxLengthValidator()) \
+(BoxVectorValidator())
 
 #define statetypes (std::vector<atom*>)(Shape)
Index: src/Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class molecule;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<atom*>)
Index: src/Actions/SelectionAction/Atoms/AtomByElementAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AtomByElementAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AtomByElementAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -41,7 +41,7 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionAtomByElementAction::performCall() {
-  LOG(1, "Selecting atoms of type " << *params.elemental);
+  LOG(1, "Selecting atoms of type " << *params.elemental.get());
   std::vector<atom *> selectedAtoms = World::getInstance().getAllAtoms(AtomsBySelection());
-  World::getInstance().selectAllAtoms(AtomByType(params.elemental));
+  World::getInstance().selectAllAtoms(AtomByType(params.elemental.get()));
   LOG(0, World::getInstance().countSelectedAtoms() << " atoms selected.");
   return Action::state_ptr(new SelectionAtomByElementState(selectedAtoms,params));
@@ -51,5 +51,5 @@
   SelectionAtomByElementState *state = assert_cast<SelectionAtomByElementState*>(_state.get());
 
-  World::getInstance().unselectAllAtoms(AtomByType(state->params.elemental));
+  World::getInstance().unselectAllAtoms(AtomByType(state->params.elemental.get()));
   BOOST_FOREACH(atom *_atom, state->selectedAtoms)
     World::getInstance().selectAtom(_atom);
@@ -61,5 +61,5 @@
   SelectionAtomByElementState *state = assert_cast<SelectionAtomByElementState*>(_state.get());
 
-  World::getInstance().selectAllAtoms(AtomByType(state->params.elemental));
+  World::getInstance().selectAllAtoms(AtomByType(state->params.elemental.get()));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Atoms/AtomByElementAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/AtomByElementAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AtomByElementAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class element;
 
+#include "Parameters/Validators/Specific/ElementValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (const element*)
 #define paramtokens ("select-atom-by-element")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (elemental)
+#define paramvalids \
+(ElementValidator())
 
 #define statetypes (std::vector<atom*>)
Index: src/Actions/SelectionAction/Atoms/AtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AtomByIdAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AtomByIdAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -38,5 +38,5 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionAtomByIdAction::performCall() {
-  const atom *Walker = World::getInstance().getAtom(AtomById(params.WalkerId));
+  const atom *Walker = World::getInstance().getAtom(AtomById(params.WalkerId.get()));
   if (Walker != NULL) {
     if (!World::getInstance().isSelected(Walker)) {
@@ -56,5 +56,5 @@
   SelectionAtomByIdState *state = assert_cast<SelectionAtomByIdState*>(_state.get());
 
-  const atom *Walker = World::getInstance().getAtom(AtomById(state->params.WalkerId));
+  const atom *Walker = World::getInstance().getAtom(AtomById(state->params.WalkerId.get()));
   World::getInstance().unselectAtom(Walker);
 
@@ -65,5 +65,5 @@
   SelectionAtomByIdState *state = assert_cast<SelectionAtomByIdState*>(_state.get());
 
-  const atom *Walker = World::getInstance().getAtom(AtomById(state->params.WalkerId));
+  const atom *Walker = World::getInstance().getAtom(AtomById(state->params.WalkerId.get()));
   World::getInstance().selectAtom(Walker);
 
Index: src/Actions/SelectionAction/Atoms/AtomByIdAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/AtomByIdAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AtomByIdAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class atom;
 
+#include "Parameters/Validators/Specific/AtomIdValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (atomId_t)
 #define paramtokens ("select-atom-by-id")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (WalkerId)
+#define paramvalids \
+(AtomIdValidator())
 
 #undef statetypes
Index: src/Actions/SelectionAction/Atoms/AtomByOrderAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/AtomByOrderAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AtomByOrderAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -39,5 +39,5 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionAtomByOrderAction::performCall() {
-  const atom *Walker = World::getInstance().getAtom(AtomByOrder(params.order));
+  const atom *Walker = World::getInstance().getAtom(AtomByOrder(params.order.get()));
   if (Walker != NULL) {
     if (!World::getInstance().isSelected(Walker)) {
Index: src/Actions/SelectionAction/Atoms/AtomByOrderAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/AtomByOrderAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/AtomByOrderAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class atom;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (int)
 #define paramtokens ("select-atom-by-order")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (order)
+#define paramvalids \
+(DummyValidator< int >())
 
 #define statetypes (atomId_t)
Index: src/Actions/SelectionAction/Atoms/ClearAllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/ClearAllAtomsAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/ClearAllAtomsAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -16,4 +18,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<atom*>)
